import { world, system, ItemStack } from "@minecraft/server";
import { ActionFormData } from "@minecraft/server-ui";
function isBlock(block, player) {
    let b = false
    try {
   player.runCommand(`fill ~~~ ~~~ ${block} [] replace barrier`);
      b = true
    }catch (error) {}
   return b;
}
world.afterEvents.itemUse.subscribe(data => {
  
  const pastel = data.itemStack
  const uva = data.source
if (pastel.typeId == "blayy:fly_artifact") {
  if (uva.isSneaking == true) {
    uva.applyKnockback(0, 0, 1, 2)
  }else{
    uva.applyKnockback(uva.getViewDirection().x, uva.getViewDirection().z, 4, 0)
  }
  
  
}
if (pastel.typeId == "blayy:slime_sling" && uva.isOnGround == true) {
  uva.applyKnockback(uva.getViewDirection().x, uva.getViewDirection().z, -4, 1)
}
if (pastel.typeId == "blayy:purple_slime_sling" && uva.isOnGround == true) {
  uva.applyKnockback(uva.getViewDirection().x, uva.getViewDirection().z, -8, 2)
}
  let normalc = {};
  if (pastel.typeId.includes("advanced")) {
    normalc.maxDistance = 20;
  }else {
    normalc.maxDistance = 8;
  }
  if (pastel.getLore() != "" && pastel.typeId.includes("mob_capture") == true) {

    const lore1 = pastel.getLore()[0]
   uva.runCommandAsync(`summon ${lore1.split("/")[0]} ${lore1.split("/")[1]} ~~~`)
   uva.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 ${pastel.typeId}`)
  }
  
    

  if (pastel.typeId == "blayy:ultimate_bone") {
let wolf =  uva.getEntitiesFromViewDirection(normalc)[0].entity
  let ent = wolf.typeId
  if (ent = "minecraft:wolf") {
    wolf.addTag("buffed_wolf")
    uva.runCommandAsync("clear @s blayy:ultimate_bone 0 1")
  }
  }
  if (pastel.typeId.includes("mob_capture") == true) {
    let wolf =  uva.getEntitiesFromViewDirection(normalc)[0].entity
    let h = wolf.getComponent("minecraft:health").currentValue
    
    class loreItem {
     constructor(itemId, lore) {
      this.itemId = itemId;
      this.lore = lore;
     }
    }
                const ItemArray = [
                    {itemId: pastel.typeId, lore: [`${wolf.typeId}/${wolf.nameTag}`]}
                ]
                const playerContainer = uva.getComponent("minecraft:inventory").container
                for (let i = 0; i < 36; i++) {
                 
                    const item = playerContainer.getItem(i)
            if (!item) continue
                        const findLore = ItemArray.find(x => x.itemId == item.typeId)
                    if (item && findLore) {
                      if (pastel.typeId.includes("iron_mob_capture") == true) {
    
    
    if (h <= 20 && pastel.getLore() == "") {
      item.setLore(findLore.lore)                      
      playerContainer.setItem(i, item)
      wolf.remove() 

    }
    
    
  }
  if (pastel.typeId.includes("emerald_mob_capture") == true && pastel.getLore() == "") {
    
    
    if (h <= 40) {
      item.setLore(findLore.lore)   
      playerContainer.setItem(i, item)
      wolf.remove() 

    }
    
    
  }
  if (pastel.typeId.includes("diamond_mob_capture") == true && pastel.getLore() == "") {
    
    if (h <= 60) {
      item.setLore(findLore.lore)
      playerContainer.setItem(i, item)
      wolf.remove() 

      
    }
    
    
  }

                    }
                }
            
        
    

  }
  
})
world.afterEvents.itemUseOn.subscribe(data => {
  console.warn("ola")
  let item = data.itemStack
  const player = data.source
  if (item.typeId === "blayy:cardbox") {
        const uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function(c) {
    var r = (Math.random() * 16) | 0,
    v = c == 'x' ? r: (r & 0x3) | 0x8;
    return v.toString(16);
  });
    if (item.getLore()[0]) {
     player.runCommandAsync(`structure load mystructure:${item.getLore()[0]} ${data.block.location.x} ${data.block.location.y+1} ${data.block.location.z}`)
        player.getComponent("equippable").setEquipment("Mainhand", new ItemStack("minecraft:air", 1))
        player.runCommandAsync(`structure delete mystructure:${item.getLore()[0]}`)
    } else {
        player.runCommandAsync(`structure save ${uuid} ${data.block.location.x} ${data.block.location.y} ${data.block.location.z} ${data.block.location.x} ${data.block.location.y} ${data.block.location.z}`)
        item.setLore([`${uuid}`])
        player.getComponent("equippable").setEquipment("Mainhand", item)
        player.runCommandAsync(`setblock ${data.block.location.x} ${data.block.location.y} ${data.block.location.z} air`)
    }
} 
})
world.afterEvents.entityHitEntity.subscribe(data => {
if (data.damagingEntity.getComponent("equippable").getEquipment("Mainhand").typeId == "blayy:impulse_gauntlet") {
  data.hitEntity.applyKnockback(data.damagingEntity.getViewDirection().x, data.damagingEntity.getViewDirection().z, 3, 1)
}
if (data.damagingEntity.getComponent("equippable").getEquipment("Mainhand").typeId == "blayy:advanced_impulse_gauntlet") {
  data.hitEntity.applyKnockback(data.damagingEntity.getViewDirection().x, data.damagingEntity.getViewDirection().z, 6, 2)
}
})
system.runInterval(async data => {
  world.getPlayers().forEach(robson => {
    if (robson.hasTag("botaslime") == true) {
      robson.removeEffect("slow_falling")
    }
  })
})